# git clone git://git.code.sf.net/p/pure-data/pd-extended
# $ git  describe --tags
# 0.43.4-28-gbc8e8b3
%define git gbc8e8b3

%define	desktop_vendor planetccrma

%define build_with_fusion 1
%define build_with_avifile 1

Summary: Pd extended
Name: pd-extended
Version: 0.43.4
Release: 1%{?git:.1.%{git}}%{?dist}
License: GPL
Group: Applications/Multimedia
URL: http://pure-data.sourceforge.net/
Source0: Pd-extended_%{version}-%{?git:%{git}-}source.tar.bz2
Source1: pd-extended.desktop
Source2: make-package-obsoletes-list
Source3: pd-subpackages
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: hicolor-icon-theme
Requires: tcllib
Packager: Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

BuildRequires: automake autoconf libtool python python-devel 
BuildRequires: flex bison rsync

BuildRequires: alsa-lib-devel jack-audio-connection-kit-devel
BuildRequires: libogg-devel libvorbis-devel libtheora-devel
BuildRequires: ladspa-devel dssi-devel liblo-devel speex-devel 
BuildRequires: libpng-devel tk-devel imlib2-devel
BuildRequires: ftgl-devel libdv-devel
BuildRequires: desktop-file-utils bzip2-devel flite-devel
BuildRequires: glib2-devel gsl-devel SDL-devel gettext-devel
BuildRequires: ImageMagick-devel ImageMagick-c++-devel
BuildRequires: libpng-devel libtiff-devel 
BuildRequires: lua-devel swig
%if 0%{?fedora} >= 14
BuildRequires: libjpeg-turbo-devel
%else
BuildRequires: libjpeg-devel
%endif
BuildRequires: libXv-devel mesa-libGLU-devel libXext-devel fftw2-devel
BuildRequires: freetype-devel which freeglut-devel
%if 0%{?build_with_avifile}
BuildRequires: avifile-devel ffmpeg-compat ffmpeg-compat-devel
%endif
%if 0%{?fedora} >= 15
BuildRequires: libv4l-devel
%endif

%if 0%{?build_with_fusion}
BuildRequires: a52dec-devel libmpeg3-devel libquicktime-devel lame-devel
%endif

# automatically generate a list of all old subpackages
# including Obsolete: and Provides: directives (but only
# for i386 as there were no x86_64 packages before)
%ifnarch x86_64
%{expand:%(%{SOURCE2} %{SOURCE3})}
%endif

%description
The Pd developer community have added some extensions to Pd, like
colored audio cords, GUI glitch prevention, and more. The pd-extended
distribution includes these patches.

%package extra
Summary: Pd extended extra externals (requires rpmfusion)
Group: Applications/Multimedia
Requires: pd-extended = %{version}-%{release}

Requires: mpg321

%description extra
This package includes pd externals that depend on packages or libraries
available in the rpmfusion repository.

%prep
%setup -q -n pd-extended

%build
%if %{?git}0
./autogen.sh
%endif

# --enable-fftw needs fftw2 and fedora does not include all libraries in its build
./configure --prefix=%{_prefix} --libdir=%{_libdir} --enable-alsa --enable-jack
make OPT_CFLAGS="%{optflags}" 

%install
%{__rm} -rf %{buildroot}

make OPT_CFLAGS="%{optflags}" DESTDIR=%{buildroot} install

# add include files necessary for building externals
%{__mkdir} -p %{buildroot}%{_libdir}/pd-extended/include
%{__install} src/*.h %{buildroot}%{_libdir}/pd-extended/include

# desktop file categories
BASE="Application AudioVideo Audio"
XTRA="X-Jack X-MIDI X-Synthesis X-Digital_Processing Midi"

%{__mkdir} -p %{buildroot}%{_datadir}/applications
desktop-file-install --vendor %{desktop_vendor} \
  --dir %{buildroot}%{_datadir}/applications \
  `for c in ${BASE} ${XTRA} ; do echo "--add-category $c " ; done` \
  %{SOURCE1}

# install the default pdextended file
# XXX install -m 0644 default.pdextended %{buildroot}%{_libdir}/pd-extended/default.pdextended

# create a link for backwards compatibility
ln -s %{_bindir}/pd %{buildroot}%{_bindir}/pdextended

# XXX

# XXX cd packages/linux_make
# XXX make OPT_CFLAGS="%{optflags}" prefix=%{_prefix} DESTDIR=%{buildroot} install

# mv pkgconfig files to where they belong
# XXX %ifarch x86_64
# XXX mkdir -p %{buildroot}%{_libdir}/pkgconfig/
### mv %{buildroot}%{_prefix}/lib/pkgconfig/Gem.pc %{buildroot}%{_libdir}/pkgconfig/
# XXX mv %{buildroot}%{_prefix}/lib/pkgconfig/pdextended.pc %{buildroot}%{_libdir}/pkgconfig/
# XXX %endif

%clean
%{__rm} -rf %{buildroot}

%post
touch --no-create %{_datadir}/icons/hicolor || :
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
   %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%postun
touch --no-create %{_datadir}/icons/hicolor || :
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
   %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

#    File not found: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/lib64/pd-extended/default.pdextended
#    File not found: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/share/applications/planetccrma-pd-extended.desktop

#    File not found: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/bin/pdextended
#    File not found: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/bin/cyclist
#    File not found: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/lib64/pd-extended/include
#    File not found by glob: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/lib64/pd-extended/extra/unauthorized/*mp3*
#    File not found: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/lib64/pd-extended/extra/iemlib/mp3play~-help.pd
#    File not found: /builddir/build/BUILDROOT/pd-extended-0.43.4-1.1.gbc8e8b3.fc21.ccrma.x86_64/usr/lib64/pd-extended/extra/pdp


%files 
%defattr(-,root,root,-)
%{_bindir}/pd
%{_bindir}/pdextended
%{_bindir}/pdreceive
%{_bindir}/pdsend
# XXX %{_bindir}/cyclist
%{_bindir}/pd-gui.tcl
%dir %{_libdir}/pd-extended
%{_libdir}/pd-extended/bin/*
%{_libdir}/pd-extended/include
%{_libdir}/pd-extended/doc
%{_libdir}/pd-extended/extra
# XXX %{_libdir}/pd-extended/default.pdextended
%{_libdir}/pd-extended/po
%{_libdir}/pd-extended/startup
%{_libdir}/pd-extended/tcl
%{_libdir}/pkgconfig/*pc
%{_includedir}/pdextended
%{_includedir}/m_pd.h
%{_datadir}/applications/planetccrma-pd-extended.desktop
%{_mandir}/man1/pd*

# what goes into extra is excluded here
# (all stuff that dependes on rpmfusion)
# XXX %exclude %{_libdir}/pd-extended/extra/unauthorized/*mp3*
# XXX %exclude %{_libdir}/pd-extended/extra/iemlib/mp3play~-help.pd
### %exclude %{_libdir}/pd-extended/extra/Gem
# XXX %exclude %{_libdir}/pd-extended/extra/pdp
### %exclude %{_includedir}/Gem

%files extra
# all mp3 stuff in unauthorized
# XXX %{_libdir}/pd-extended/extra/unauthorized/*mp3*
# iemlib help files that include mp3 references
# XXX %{_libdir}/pd-extended/extra/iemlib/mp3play~-help.pd
# Gem, of course
### %{_libdir}/pd-extended/extra/Gem
### %{_includedir}/Gem
# pdp
# XXX %{_libdir}/pd-extended/extra/pdp

%changelog
* Fri Dec 19 2014 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.43.4-1.1.gbc8e8b3
- clone latest git to build on fc21, completely redo the build process

* Sun Jan 12 2014 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.43.4-1
- redo lib64 s_main.c patch

* Sat Jan 11 2014 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.43.4-1
- add lua 5.2 patches from Martin Peach to build with lua 5.2
- re-add the lib64 patch

* Sun Sep 15 2013 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.43.4-1
- add pd-extended-makefile.patch to fix build of gem
- fix Gem's configure.ac
- build everything with the default Fedora optflags (crucial to get
  the right architecture build on Pidora)

* Thu Sep  5 2013 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.43.4-1
- trying to redo the whole build infrastructure and get sane build flags
  that mimic the Fedora defaults for package building. One example here:
  https://aur.archlinux.org/packages/pd/pd-extended/PKGBUILD
- add lua-devel as build requirement
- add fix for lua5.1 library link
- add swig to build requirements
- add patch for tcl_widgetbehavior:
  tcl_widgetbehavior.c:297:5: warning: format ‘%lx’ expects argument of type ‘long unsigned int’, but argument 4 has type ‘struct _glist *’ [-Wformat]
- many changes in the spec file

* Mon Apr 22 2013 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.43.4-1
- update to 0.43.4
- remove pidip external, it is gone from the distribution due to license
  conflicts. We will have to package it separately (http://ydegoyon.free.fr/pidip.html)

* Tue Jun 26 2012 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.43.1-1
- update to current rsync version (0.43.1)
  see http://puredata.info/docs/developer/GettingPdSource
  rsync -av --delete rsync://128.238.56.50/distros/pd-extended/ pd-extended/ 

* Fri Dec  3 2010 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.42.5-2
- add an x86_64 specific patch to fix the load of pd-gui, it falsely
  assumes stuff is in /lib/ instead of /lib64/

* Tue Nov  9 2010 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.42.5-1
- changed libjpeg-turbo-devel for fc14, updated to 0.42.5, also build
  for x86_64.
- add rsync build dependency (needed for the install target)
- pdsettings is now pdextended
- stuff is now installed in /usr/lib/pd-extended, the binary is pdextended
- create a backwards compatibility link in /usr/bin/pd to pdextended

* Wed Nov 25 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4-4
- reenabled building with avifile (fc12 rebuild)

* Tue Oct 27 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4-3
- add tcllib explicit runtime dependency
- _really_ fix the font path in /usr/lib/pd/default.pdsettins

* Mon Oct 26 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4-2
- fix path for Vera font in pidip and script that generates default 
  settings file, include default settings file in package

* Mon Aug 10 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4-1
- more fixes for Fedora 11 builds (quicktime library discovery and
  quicktime include paths)

* Tue Aug  4 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4-1
- add a QT4 related patch for building on fc11 (patch3)

* Tue Jul 28 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- add "prefix" and modify DESTDIR so that pd finds its own
  directories automatically

* Fri Jul 24 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- removed iem_tab from the x86_64 build, only two instances of -fPIC
  needed for a build. Two patches generated:
  patch0: with the fpic additions
  patch1: removed iem_tab from the x86_64 build

* Thu Jul 23 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- enabled x86_64 build, but compilation fails. First with a missing -fPIC
  in the externals/Makefile for cyclone, then with:
externals/iem/iem_tab/src/tab_add_scalar.c:85: error: incompatible types in assignment
  so quit for now. 

* Wed Jul 22 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4-1
- many changes in spec file

* Wed Jul 15 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4-1
- automatically generate Provides: and Obsoletes: for all old
  subpackages
- add all header files to /usr/lib/pd/include/ for building externals
- add "extra" subpackage to include stuff that needs rpmfusion

* Sun Jul  5 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4
- give up separate subpackages, too much trouble, we'll probably have
  to split up things that depend on rpmfusion (so two packages instead
  of one)

* Mon Jun 29 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.41.4
- updated to 0.41.4
- patch3 (libmpeg3open) does not patch, comment out
- update Gem to 0.91-3, add a52dec-devel dependency for Gem
- add liblo-devel dependency (for dssi external)
- add glib2-devel, flite-devel for moocow externals
- flext is no longer included in pd-extended

* Tue Mar 10 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.40.3
- patch4, patch5 no longer patch, ommit
- downloaded Gem 0.91-2 (is not included in pd-extended official release)
- add fftw3-devel build requirement (bsaylor external needs it)
- add dssi-devel to build requirements (for dssi external)
- run bootstrap in externals/pdp
- run autoconf in externals/pidip, add libtheora-devel build requirement
- no longer possible to easily disable pdp an pidip, just enabled them for now
  and remove all references to the build_pdp and build_pidip symbols
- temporarily disable syncgrain, does not build

* Wed Nov 26 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- redo gcc43 patch to patch with no fuzz for fc10
- change build dependency to stk-devel for >= fc9
- added patch for stk type change (MY_FLOAT to FLOAT32)

* Mon Jun 30 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added patches for gcc43 build on fc9
- disabled pidip build, source is not compatible with fc9's version
  of ImageMagick (see: http://lists.puredata.info/pipermail/pd-list/2006-01/034721.html)

* Wed Nov 14 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- updated desktop categories
- Gem: do not force glversion to 1.5, needs at least 2.0
- Gem: fix location of libmpeg3.h include file

* Fri Aug  3 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.3-1.cvs.07.07.23
- removed pd-loaders requires on pd-extended package
error: unpacking of archive failed on file /usr/lib/pd/doc/5.reference/freeverb/freeverb~-help.pd;46b383f2: cpio: open
 
* Thu Aug  2 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.3-1.cvs.07.07.23
- added rtc-lib abstraction
- excluded deprecated externals in pd subpackage file list
- ffmpeg is no longer needed to build gem
- remove ix and gripd leftover files

* Wed Aug  1 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.3-1.cvs.07.07.23
- the metro-dev%* ugens are breaking the rpm build. I don't know why and
  workarounds I tried have not worked out, so for now I'm just erasing
  them from the install. The sympton was that installed files were not 
  packaged - maybe because those files have a "%%" in them, but there are
  other files with that that package fine. Arghh. 
- added Hans's desktop file and icon, desktop entry is for "pd -rt -jack"
- redid perl one-liner to disable gem and flext builds in the generic
  pd-extended target (the order had changed)
- build gem with the built in target instead of separately

* Mon Jul 23 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.3-1.cvs.07.07.23
- pd no longer needs to be patched
- added build requirements for pidip (ImageMagick and bzip2-devel
- HammingTable fix for syncgrain still needed
- Hans Steiner fixed a couple of problems in cvs
- make sure that "%%"'s in file lists get escaped otherwise the 
  install fails to find files (ampersand expands to nothing...)

* Wed Jun  6 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-3.cvs.06.11.20
- rebuild on fc7, man pages are stored in the proper directory so make
  the move conditional
- add macro in Gem build to enable the definition of INT64_C even when
  using c++
- src/Pixes/filmFFMPEG.h needs an <errno.h> include
...
- do not build Gem for now on fc7
- disable grill/py external build, has problems with python 2.5 on fc7

* Thu Mar  1 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-3.cvs.06.11.20
- rebuild with new libavformat.so.51
- rebuilt libmpeg3 for fc5, require libmpeg3-devel

* Tue Dec 26 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-2.cvs.06.11.20
- fix OSCx configure script, tries to link with "-lpd"
- added libquicktime and ffmpeg to the pd-gem runtime dependencies

* Wed Dec 13 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-2.cvs.06.11.20
- build on fc6
- removed "pd" from the build dependencies, we point Gem to the local 
  pd source tree (see perl substitution in the Gem build above)
- add patch3, newer versions of libmpeg3 (1.7.x) have two arguments 
  to the open function
- point PDPATH to the built in pd source tree in flext and fluid

* Wed Nov 22 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-2.cvs.06.11.20
- fix syncgrain build problem, add proper HammingTable.h include
  (flext no longer includes AudioDefs.h so that include is missing)

* Tue Nov 21 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-2.cvs.06.11.20
- GemLibs: glm and particle are now within Gem itself, liborb is
  deprecated ("Gem's SpaceOrb-support has been dropped completely"), 
  so remove build of GemLibs
- Gem: fixed ImageMagick detection (needed -c++-devel package)
  add "which" to list of build dependencies
  . use ftgl instead of gltt
  . needs artoolkit?  
  . added specific ftgl require to pd-gem
- syncgrain does not build ("envtable" not defined in main.cpp), 
  disable its build for now

* Mon Nov 20 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-0.3.cvs.06.11.20
- updated to cvs of 2006.11.20
- added hack for flatspace_install (erased duplicated help files)

* Thu Sep 28 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-0.2.cvs.06.09.07
- pidip was in the wrong pd-extended package (needs to be in "extra")

* Thu Sep 28 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- remove all CVS directories
- tried to add better summaries and descriptions to all external
  collection subpackages, some light testing (adding required
  libraries for proper startup) - only done through pd-hardware...

* Wed Sep 27 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- disable ARB opengl extensions on gem for fc4 (patch2 and --disable-ARB
  on configuration step). See:
  http://lists.puredata.info/pipermail/pd-list/2006-01/034540.html
- create pd-unauthorized-mp3 package with all mp3 related stuff
- segregate mp3, pdp and Gem into separate pd-extended-extra meta
  package

* Tue Sep 26 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added Epochs to pd-gem, pd-iemlib, pd-zexy, pd-fftease, pd-fluid
  and pd-syncgrain as they had versions before that were greater
  than the pd-extended version number (also added the epoch to the
  requirements of pd-extended)
- missing externals (from previous versions of Planet CCRMA):
  pd-percolate: port to pd stopped and no longer available
  (possibly now available as part of ggee, see:
    http://lists.puredata.info/pipermail/pd-list/2001-05/002271.html)
- readd extra include files to /usr/lib/pd/include
- add links from /usr/lib/pd/extra to all .pd and .pd_linux files
  that live in subdirectories of /usr/lib/pd/extra/, otherwise
  we need one path for each external collection

* Mon Sep 25 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- tried to build gripd but I could not find the required "Installer" 
  software for the python GUI

* Tue Sep 19 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- build grill externals: flext, vasp, fftease, dynext, py, xsample
  (build procedures extracted from previous separate spec files)
  build footils externals: fluid, syncgrain, pool, absattr,
  deljoin, splitjoin

* Mon Sep 18 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2-0.1.cvs.06.09.07
- first succesful build. 
- does not build extensions, flext or gem targets in global
  extended_install target. 
- build pdp and pidip, add additional build requirements

* Sat Aug 12 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2
- updated to current cvs

* Mon Jul 31 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2
- added imlib2-devel to build requirements (pidip needs it)

* Tue Jul 25 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.39.2
- changed package name to pd-extended, build all of it, both pd and
  the external collection

* Sun Jul 23 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- cvs snapshot of 2006.07.23
- add build requirements for pdp/pidip
- remove pddp help files that conflict with pd
- ignore the pd install

* Sat Jun 10 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- initial build.
- do not build pdp/pidip
